using System;
using System.Collections.Generic;
using System.Text;

namespace QD_GUI
{
    public class Queue
    {
        #region XML-DTD

        /*   <!ELEMENT queue          (
         *                             version,
         *                             system_type?,
         *                             warning?,
         *                             current_index,
         *                             index+,
         *                             results_successfully_sent?,
         *                             download_rate?,
         *                             upload_rate?,
         *                             performance_fraction?,
         *                             pph?,
         *                             ppd?,
         *                             ppw?,
         *                             ppy?
         *                            )>
         * 
         * QueueDump.Queue.Version
         * QueueDump.Queue.SystemType
         * QueueDump.Queue.Warning
         * QueueDump.Queue.CurrentIndex
         * QueueDump.Queue.Index[0]
         * ...
         * QueueDump.Queue.Index[9]
         * QueueDump.Queue.ResultsSuccessfullySent
         * QueueDump.Queue.DownloadRate.Speed
         * QueueDump.Queue.DownloadRate.Units
         * QueueDump.Queue.UploadRate.Speed
         * QueueDump.Queue.UploadRate.Units
         * QueueDump.Queue.PerformanceFraction.Fraction
         * QueueDump.Queue.PerformanceFraction.Units
         * QueueDump.Queue.PPH
         * QueueDump.Queue.PPD
         * QueueDump.Queue.PPW
         * QueueDump.Queue.PPY
         */

        #endregion XML-DTD

        private string sVersion = "";
        private string sSystemType = "";
        private string sWarning = "";
        private string sCurrentIndex = "";
        private Index[] oIndex = new Index[10];
        private string sResultsSuccessfullySent = "";
        private UploadDownloadRate oDownloadRate = new UploadDownloadRate();
        private UploadDownloadRate oUploadRate = new UploadDownloadRate();
        private PerformanceFraction oPerformanceFraction = new PerformanceFraction();
        private string sPPH = "";
        private string sPPD = "";
        private string sPPW = "";
        private string sPPY = "";

        #region Properties

        public string Version
        {
            get
            {
                return sVersion;
            }
            set
            {
                sVersion = value;
            }
        }

        public string SystemType
        {
            get
            {
                return sSystemType;
            }
            set
            {
                sSystemType = value;
            }
        }

        public string Warning
        {
            get
            {
                return sWarning;
            }
            set
            {
                sWarning = value;
            }
        }

        public string CurrentIndex
        {
            get
            {
                return sCurrentIndex;
            }
            set
            {
                sCurrentIndex = value;
            }
        }

        public Index[] Index
        {
            get
            {
                return oIndex;
            }
            set
            {
                oIndex = value;
            }
        }

        public string ResultsSuccessfullySent
        {
            get
            {
                return sResultsSuccessfullySent;
            }
            set
            {
                sResultsSuccessfullySent = value;
            }

        }

        public UploadDownloadRate DownloadRate
        {
            get
            {
                return oDownloadRate;
            }
            set
            {
                oDownloadRate = value;
            }
        }

        public UploadDownloadRate UploadRate
        {
            get
            {
                return oUploadRate;
            }
            set
            {
                oUploadRate = value;
            }
        }


        public PerformanceFraction PerformanceFraction
        {
            get
            {
                return oPerformanceFraction;
            }
            set
            {
                oPerformanceFraction = value;
            }
        }

        public string PPH
        {
            get
            {
                return sPPH;
            }
            set
            {
                sPPH = value;
            }
        }

        public string PPD
        {
            get
            {
                return sPPD;
            }
            set
            {
                sPPD = value;
            }
        }

        public string PPW
        {
            get
            {
                return sPPW;
            }
            set
            {
                sPPW = value;
            }
        }

        public string PPY
        {
            get
            {
                return sPPY;
            }
            set
            {
                sPPY = value;
            }
        }

        #endregion Properties
    }
}